#include "testApp.h"
#include "maximilian.h"

int x=1;
int y=1;

testApp::~testApp() {
	
	delete beat.myData;
	delete beats.myData;
	
}

//--------------------------------------------------------------
void testApp::setup(){	
	// register touch events
	ofRegisterTouchEvents(this);
	
	// initialize the accelerometer
	ofxAccelerometer.setup();
	
	//iPhoneAlerts will be sent to this.
	ofxiPhoneAlerts.addListener(this);
	
	sampleRate 			= 44100;
	initialBufferSize	= 512;
	lAudio				= new float[initialBufferSize];
	rAudio				= new float[initialBufferSize];
	
	memset(lAudio, 0, initialBufferSize * sizeof(float));
	memset(rAudio, 0, initialBufferSize * sizeof(float));
	
	beat.load(ofToDataPath("beat2.wav"));
	beat.getLength();
	beats.load(ofToDataPath("remoteatmos.wav"));
	beats.getLength();

	ofSoundStreamSetup(2,0,this, sampleRate, initialBufferSize, 4);
	


	//If you want a landscape oreintation 
	iPhoneSetOrientation(OFXIPHONE_ORIENTATION_LANDSCAPE_RIGHT);
	ofBackground(0,0,0);
}


//--------------------------------------------------------------
void testApp::update(){

}

//--------------------------------------------------------------
void testApp::draw(){
		
	float boxW		= 200.0;
	float boxH		= boxW*0.75;
	
	float topY		= 30;
	float leftX		= 30;
	float rightX	= leftX + boxW + 20;
	
	// draw the left:
	ofSetColor(0x333333);
	ofRect(leftX,topY,boxW,boxH);
	ofSetColor(0xFFFFFF);
	for (int i = 0; i < initialBufferSize; i++){
		float x = ofMap(i, 0, initialBufferSize, 0, boxW, true);
		ofLine(leftX+x,topY + boxH/2,leftX+x,topY + boxH/2 + lAudio[i]*boxH*0.5);
	}
	
	// draw the right:
	ofSetColor(0x333333);
	ofRect(rightX,topY,boxW,boxH);
	ofSetColor(0xFFFFFF);
	for (int i = 0; i < initialBufferSize; i++){
		float x = ofMap(i, 0, initialBufferSize, 0, boxW, true);	
		ofLine(rightX+x,topY + boxH/2,rightX+x,topY + boxH/2 + rAudio[i]*boxH*0.5);
	}
	
	ofSetColor(0x333333);
	char reportString[255];
	ofDrawBitmapString(reportString,leftX,topY + boxH + 20);
	
	
}

//--------------------------------------------------------------
void testApp::audioRequested(float * output, int bufferSize, int nChannels){
	
	if( initialBufferSize != bufferSize ){
		ofLog(OF_LOG_ERROR, "your buffer size was set to %i - but the stream needs a buffer size of %i", initialBufferSize, bufferSize);
		return;
	}	
	
	for (int i = 0; i < bufferSize; i++){
		sample2=beats.play(x*0.001, 0, beats.length);
		sample=beat.play(0.5,0,beat.length);
		mymix.stereo(sample+sample2, outputs, 0.5);

		lAudio[i] = output[i*nChannels    ] = outputs[0];
		rAudio[i] = output[i*nChannels + 1] = outputs[1];
		
	}
	
}

//--------------------------------------------------------------
void testApp::audioReceived(float * input, int bufferSize, int nChannels){

}

//--------------------------------------------------------------
void testApp::exit(){

}

//--------------------------------------------------------------
void testApp::touchDown(ofTouchEventArgs &touch){

	x=touch.x;
	y=touch.y;

	
}

//--------------------------------------------------------------
void testApp::touchMoved(ofTouchEventArgs &touch){
	
	x=touch.x;
	y=touch.y;

	
}

//--------------------------------------------------------------
void testApp::touchUp(ofTouchEventArgs &touch){

}

//--------------------------------------------------------------
void testApp::touchDoubleTap(ofTouchEventArgs &touch){

}

//--------------------------------------------------------------
void testApp::lostFocus(){

}

//--------------------------------------------------------------
void testApp::gotFocus(){

}

//--------------------------------------------------------------
void testApp::gotMemoryWarning(){

}

//--------------------------------------------------------------
void testApp::deviceOrientationChanged(int newOrientation){

}

